/**
 * Account.java
 *
 * This file was auto-generated from WSDL
 * by the Apache Axis 1.4 Mar 02, 2009 (07:08:06 PST) WSDL2Java emitter.
 */

package com.google.api.ads.adwords.axis.v201109.mcm;


/**
 * Represents a single AdWords account.
 */
public class Account  implements java.io.Serializable {
    /* The 10-digit ID that uniquely identifies the AdWords account.
     * <span class="constraint ReadOnly">This field is read only and should
     * not be set for following {@link Operator}s : ADD.  If this field is
     * sent to the API, it will be ignored.</span> */
    private java.lang.Long customerId;

    /* The email address of the account's first login user, if any.
     * <span class="constraint ReadOnly">This field is read only and should
     * not be set for following {@link Operator}s : ADD.  If this field is
     * sent to the API, it will be ignored.</span> */
    private java.lang.String login;

    /* The company name of the account, if any.
     *                 <span class="constraint ReadOnly">This field is read
     * only and should not be set for following {@link Operator}s : ADD.
     * If this field is sent to the API, it will be ignored.</span> */
    private java.lang.String companyName;

    /* Whether this account can manage clients.
     *                 <span class="constraint ReadOnly">This field is read
     * only and should not be set for following {@link Operator}s : ADD.
     * If this field is sent to the API, it will be ignored.</span> */
    private java.lang.Boolean canManageClients;

    /* The currency in which this account operates.
     *                 We support a subset of the currency codes derived
     * from the ISO 4217 standard.
     *                 See <a href="http://code.google.com/apis/adwords/docs/developer/adwords_api_currency.html"
     * >Currency Codes</a> for the currently supported currencies.
     *                 <p>
     *                 This field can only be set during creation of the
     * account.
     *                 <span class="constraint Required">This field is required
     * and should not be {@code null} when it is contained within {@link
     * Operator}s : ADD.</span>
     *                 <span class="constraint StringLength">The length of
     * this string should be between 3 and 3, inclusive.</span> */
    private java.lang.String currencyCode;

    /* The local timezone ID for this Account.
     *                 See <a href="http://code.google.com/apis/adwords/docs/developer/adwords_api_timezones.html"
     * >Time Zone Codes</a> for the currently supported list.
     *                 <p>
     *                 This field can only be set during creation of the
     * account.
     *                 <p>
     *                 This field is not provided by {@link ServicedAccountService}.
     * <span class="constraint Required">This field is required and should
     * not be {@code null} when it is contained within {@link Operator}s
     * : ADD.</span> */
    private java.lang.String dateTimeZone;

    public Account() {
    }

    public Account(
           java.lang.Long customerId,
           java.lang.String login,
           java.lang.String companyName,
           java.lang.Boolean canManageClients,
           java.lang.String currencyCode,
           java.lang.String dateTimeZone) {
           this.customerId = customerId;
           this.login = login;
           this.companyName = companyName;
           this.canManageClients = canManageClients;
           this.currencyCode = currencyCode;
           this.dateTimeZone = dateTimeZone;
    }


    /**
     * Gets the customerId value for this Account.
     * 
     * @return customerId   * The 10-digit ID that uniquely identifies the AdWords account.
     * <span class="constraint ReadOnly">This field is read only and should
     * not be set for following {@link Operator}s : ADD.  If this field is
     * sent to the API, it will be ignored.</span>
     */
    public java.lang.Long getCustomerId() {
        return customerId;
    }


    /**
     * Sets the customerId value for this Account.
     * 
     * @param customerId   * The 10-digit ID that uniquely identifies the AdWords account.
     * <span class="constraint ReadOnly">This field is read only and should
     * not be set for following {@link Operator}s : ADD.  If this field is
     * sent to the API, it will be ignored.</span>
     */
    public void setCustomerId(java.lang.Long customerId) {
        this.customerId = customerId;
    }


    /**
     * Gets the login value for this Account.
     * 
     * @return login   * The email address of the account's first login user, if any.
     * <span class="constraint ReadOnly">This field is read only and should
     * not be set for following {@link Operator}s : ADD.  If this field is
     * sent to the API, it will be ignored.</span>
     */
    public java.lang.String getLogin() {
        return login;
    }


    /**
     * Sets the login value for this Account.
     * 
     * @param login   * The email address of the account's first login user, if any.
     * <span class="constraint ReadOnly">This field is read only and should
     * not be set for following {@link Operator}s : ADD.  If this field is
     * sent to the API, it will be ignored.</span>
     */
    public void setLogin(java.lang.String login) {
        this.login = login;
    }


    /**
     * Gets the companyName value for this Account.
     * 
     * @return companyName   * The company name of the account, if any.
     *                 <span class="constraint ReadOnly">This field is read
     * only and should not be set for following {@link Operator}s : ADD.
     * If this field is sent to the API, it will be ignored.</span>
     */
    public java.lang.String getCompanyName() {
        return companyName;
    }


    /**
     * Sets the companyName value for this Account.
     * 
     * @param companyName   * The company name of the account, if any.
     *                 <span class="constraint ReadOnly">This field is read
     * only and should not be set for following {@link Operator}s : ADD.
     * If this field is sent to the API, it will be ignored.</span>
     */
    public void setCompanyName(java.lang.String companyName) {
        this.companyName = companyName;
    }


    /**
     * Gets the canManageClients value for this Account.
     * 
     * @return canManageClients   * Whether this account can manage clients.
     *                 <span class="constraint ReadOnly">This field is read
     * only and should not be set for following {@link Operator}s : ADD.
     * If this field is sent to the API, it will be ignored.</span>
     */
    public java.lang.Boolean getCanManageClients() {
        return canManageClients;
    }


    /**
     * Sets the canManageClients value for this Account.
     * 
     * @param canManageClients   * Whether this account can manage clients.
     *                 <span class="constraint ReadOnly">This field is read
     * only and should not be set for following {@link Operator}s : ADD.
     * If this field is sent to the API, it will be ignored.</span>
     */
    public void setCanManageClients(java.lang.Boolean canManageClients) {
        this.canManageClients = canManageClients;
    }


    /**
     * Gets the currencyCode value for this Account.
     * 
     * @return currencyCode   * The currency in which this account operates.
     *                 We support a subset of the currency codes derived
     * from the ISO 4217 standard.
     *                 See <a href="http://code.google.com/apis/adwords/docs/developer/adwords_api_currency.html"
     * >Currency Codes</a> for the currently supported currencies.
     *                 <p>
     *                 This field can only be set during creation of the
     * account.
     *                 <span class="constraint Required">This field is required
     * and should not be {@code null} when it is contained within {@link
     * Operator}s : ADD.</span>
     *                 <span class="constraint StringLength">The length of
     * this string should be between 3 and 3, inclusive.</span>
     */
    public java.lang.String getCurrencyCode() {
        return currencyCode;
    }


    /**
     * Sets the currencyCode value for this Account.
     * 
     * @param currencyCode   * The currency in which this account operates.
     *                 We support a subset of the currency codes derived
     * from the ISO 4217 standard.
     *                 See <a href="http://code.google.com/apis/adwords/docs/developer/adwords_api_currency.html"
     * >Currency Codes</a> for the currently supported currencies.
     *                 <p>
     *                 This field can only be set during creation of the
     * account.
     *                 <span class="constraint Required">This field is required
     * and should not be {@code null} when it is contained within {@link
     * Operator}s : ADD.</span>
     *                 <span class="constraint StringLength">The length of
     * this string should be between 3 and 3, inclusive.</span>
     */
    public void setCurrencyCode(java.lang.String currencyCode) {
        this.currencyCode = currencyCode;
    }


    /**
     * Gets the dateTimeZone value for this Account.
     * 
     * @return dateTimeZone   * The local timezone ID for this Account.
     *                 See <a href="http://code.google.com/apis/adwords/docs/developer/adwords_api_timezones.html"
     * >Time Zone Codes</a> for the currently supported list.
     *                 <p>
     *                 This field can only be set during creation of the
     * account.
     *                 <p>
     *                 This field is not provided by {@link ServicedAccountService}.
     * <span class="constraint Required">This field is required and should
     * not be {@code null} when it is contained within {@link Operator}s
     * : ADD.</span>
     */
    public java.lang.String getDateTimeZone() {
        return dateTimeZone;
    }


    /**
     * Sets the dateTimeZone value for this Account.
     * 
     * @param dateTimeZone   * The local timezone ID for this Account.
     *                 See <a href="http://code.google.com/apis/adwords/docs/developer/adwords_api_timezones.html"
     * >Time Zone Codes</a> for the currently supported list.
     *                 <p>
     *                 This field can only be set during creation of the
     * account.
     *                 <p>
     *                 This field is not provided by {@link ServicedAccountService}.
     * <span class="constraint Required">This field is required and should
     * not be {@code null} when it is contained within {@link Operator}s
     * : ADD.</span>
     */
    public void setDateTimeZone(java.lang.String dateTimeZone) {
        this.dateTimeZone = dateTimeZone;
    }

    private java.lang.Object __equalsCalc = null;
    public synchronized boolean equals(java.lang.Object obj) {
        if (!(obj instanceof Account)) return false;
        Account other = (Account) obj;
        if (obj == null) return false;
        if (this == obj) return true;
        if (__equalsCalc != null) {
            return (__equalsCalc == obj);
        }
        __equalsCalc = obj;
        boolean _equals;
        _equals = true && 
            ((this.customerId==null && other.getCustomerId()==null) || 
             (this.customerId!=null &&
              this.customerId.equals(other.getCustomerId()))) &&
            ((this.login==null && other.getLogin()==null) || 
             (this.login!=null &&
              this.login.equals(other.getLogin()))) &&
            ((this.companyName==null && other.getCompanyName()==null) || 
             (this.companyName!=null &&
              this.companyName.equals(other.getCompanyName()))) &&
            ((this.canManageClients==null && other.getCanManageClients()==null) || 
             (this.canManageClients!=null &&
              this.canManageClients.equals(other.getCanManageClients()))) &&
            ((this.currencyCode==null && other.getCurrencyCode()==null) || 
             (this.currencyCode!=null &&
              this.currencyCode.equals(other.getCurrencyCode()))) &&
            ((this.dateTimeZone==null && other.getDateTimeZone()==null) || 
             (this.dateTimeZone!=null &&
              this.dateTimeZone.equals(other.getDateTimeZone())));
        __equalsCalc = null;
        return _equals;
    }

    private boolean __hashCodeCalc = false;
    public synchronized int hashCode() {
        if (__hashCodeCalc) {
            return 0;
        }
        __hashCodeCalc = true;
        int _hashCode = 1;
        if (getCustomerId() != null) {
            _hashCode += getCustomerId().hashCode();
        }
        if (getLogin() != null) {
            _hashCode += getLogin().hashCode();
        }
        if (getCompanyName() != null) {
            _hashCode += getCompanyName().hashCode();
        }
        if (getCanManageClients() != null) {
            _hashCode += getCanManageClients().hashCode();
        }
        if (getCurrencyCode() != null) {
            _hashCode += getCurrencyCode().hashCode();
        }
        if (getDateTimeZone() != null) {
            _hashCode += getDateTimeZone().hashCode();
        }
        __hashCodeCalc = false;
        return _hashCode;
    }

    // Type metadata
    private static org.apache.axis.description.TypeDesc typeDesc =
        new org.apache.axis.description.TypeDesc(Account.class, true);

    static {
        typeDesc.setXmlType(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/mcm/v201109", "Account"));
        org.apache.axis.description.ElementDesc elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("customerId");
        elemField.setXmlName(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/mcm/v201109", "customerId"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "long"));
        elemField.setMinOccurs(0);
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("login");
        elemField.setXmlName(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/mcm/v201109", "login"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setMinOccurs(0);
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("companyName");
        elemField.setXmlName(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/mcm/v201109", "companyName"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setMinOccurs(0);
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("canManageClients");
        elemField.setXmlName(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/mcm/v201109", "canManageClients"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "boolean"));
        elemField.setMinOccurs(0);
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("currencyCode");
        elemField.setXmlName(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/mcm/v201109", "currencyCode"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setMinOccurs(0);
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
        elemField = new org.apache.axis.description.ElementDesc();
        elemField.setFieldName("dateTimeZone");
        elemField.setXmlName(new javax.xml.namespace.QName("https://adwords.google.com/api/adwords/mcm/v201109", "dateTimeZone"));
        elemField.setXmlType(new javax.xml.namespace.QName("http://www.w3.org/2001/XMLSchema", "string"));
        elemField.setMinOccurs(0);
        elemField.setNillable(false);
        typeDesc.addFieldDesc(elemField);
    }

    /**
     * Return type metadata object
     */
    public static org.apache.axis.description.TypeDesc getTypeDesc() {
        return typeDesc;
    }

    /**
     * Get Custom Serializer
     */
    public static org.apache.axis.encoding.Serializer getSerializer(
           java.lang.String mechType, 
           java.lang.Class _javaType,  
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanSerializer(
            _javaType, _xmlType, typeDesc);
    }

    /**
     * Get Custom Deserializer
     */
    public static org.apache.axis.encoding.Deserializer getDeserializer(
           java.lang.String mechType, 
           java.lang.Class _javaType,  
           javax.xml.namespace.QName _xmlType) {
        return 
          new  org.apache.axis.encoding.ser.BeanDeserializer(
            _javaType, _xmlType, typeDesc);
    }

}
